/* This file contains any configuration-dependent data for mpi.h */
#ifndef MPI_DEFS
#define MPI_DEFS

#include "mpi_fortdefs.h"

#include <stdint.h> /* for __WORDSIZE */

#if __WORDSIZE == 64
typedef long MPI_Aint;
#else
typedef int MPI_Aint;
#endif

/* MPI_STATUS_SIZE is not strictly required in C; however, it should match
   the value for Fortran */
#define MPI_STATUS_SIZE 4

/* 
   Status object.  It is the only user-visible MPI data-structure 
   The "count" field is PRIVATE; use MPI_Get_count to access it. 
 */
typedef struct { 
    int count;
    int MPI_SOURCE;
    int MPI_TAG;
    int MPI_ERROR;
#if (MPI_STATUS_SIZE > 4)
    int extra[MPI_STATUS_SIZE - 4];
#endif
} MPI_Status;

#define USE_STDARG 1

#define ROMIO 1

#include "mpio.h"

#endif /* MPI_DEFS */
