#!/bin/bash
# Copyright (C) 2006 QLogic Corporation, All rights reserved.
# Copyright 2005, 2006, PathScale, Inc. All rights reserved.
#
# Permission is granted to PathScale customers to use this software in 
# source and binary forms, with or without modification, provided that 
# the following conditions are met: 
# 
# + All copies of source code must retain the above copyright notice, 
#   this list of conditions and the following disclaimer. 
# 
# + Customer has a valid license agreement from PathScale, Inc. for the 
#   software product with which this software is originally distributed. 
# 
# + Redistribution of original or modified versions to third parties is 
#   prohibited without specific prior written permission of PathScale, 
#   Inc. 
# 
# + If customer makes modifications to this software, and provides those 
#   modifications to PathScale, customer assigns to PathScale, Inc. 
#   ownership of the provided modifications and all intellectual property 
#   rights embodied in those modifications. 
# 
# + The name of PathScale, Inc. may not be used to endorse or promote 
#   products derived from this software without specific prior written 
#   permission. 
# 
# THIS SOFTWARE IS PROVIDED BY PATHSCALE, INC. AND ITS LICENSORS "AS IS" 
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL PATHSCALE, INC. OR ITS 
# LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 

if [ -n "$IPATH_DISTRO" ]; then
    echo "*** Kernel/distribution selection forcibly set to $IPATH_DISTRO" 1>&2
    distro="$IPATH_DISTRO"
elif grep -sq 'Nahant Update 2' /etc/redhat-release; then
    distro=rhel4_U2
elif grep -sq 'Nahant Update 3' /etc/redhat-release; then
    distro=rhel4_U3
elif grep -sq 'Nahant Update 4' /etc/redhat-release; then
    distro=rhel4_U4
elif grep -sq 'CentOS release 4.2' /etc/redhat-release; then
    distro=rhel4_U2
elif grep -sq 'CentOS release 4.3' /etc/redhat-release; then
    distro=rhel4_U3
elif grep -sq 'CentOS release 4.4' /etc/redhat-release; then
    distro=rhel4_U4
elif grep -sq 'SUSE LINUX Enterprise Server 9' /etc/SuSE-release && \
    grep -sq 'PATCHLEVEL = 3' /etc/SuSE-release; then
    distro=sles9sp3
elif grep -sq 'SUSE Linux Enterprise Server 10' /etc/SuSE-release; then
    distro=sles10
elif grep -sq 'SuSE Linux 9.3' /etc/SuSE-release; then
    distro=suse9.3
elif grep -sq 'Fedora Core release 3' /etc/fedora-release; then
    distro=fc3
elif grep -sq 'Fedora Core release 4' /etc/fedora-release; then
    distro=fc4
    if echo $KVER | grep -sq '^2.6.16'; then
        distro=fc4_2.6.16
    elif echo $KVER | grep -sq '^2.6.17'; then
        distro=fc4_2.6.17
    else
        echo '*** Unsupported Linux kernel release:' $KVER 1>&2
	exit 1
    fi
else
    echo '*** You are running an unsupported Linux distribution' 1>&2
    exit 1
fi
